
---------------------------------------
--             percent bar for lotro
--
--            by FreePlay 10/13/2011              
--
--              Version 0.2beta
---------------------------------------

percentBar = class();

function percentBar:Constructor()
   --Turbine.UI.Window:Constructor(self)
    
    self.max = 0
    self.min = 0
    self.curr = 0
    self.mWidth = 0
    self.mHeight = 0
    self.mode = 1
    self.percent = 0
    self.background = ""
    --self:SetPosition(0,0)
    
    self.backLbl = Turbine.UI.Control()
   
    self.backLbl:SetZOrder(13)
    self.backLbl:SetMouseVisible(false)
    self.frontLbl = Turbine.UI.Label()
  
    self.frontLbl:SetZOrder(14)
    self.frontLbl:SetMouseVisible(false)
    self.txtLbl = Turbine.UI.Label()
   
    self.txtLbl:SetZOrder(15)
    self.txtLbl:SetMouseVisible(false)
   self.txtLbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );

    
    
end
function percentBar:SetVisible(b)
	self.txtLbl:SetVisible(b)
	self.frontLbl:SetVisible(b)
	self.backLbl:SetVisible(b)
end
function percentBar:SetPar(p)
	self.txtLbl:SetParent(p)
	self.frontLbl:SetParent(p)
	self.backLbl:SetParent(p)
end
function percentBar:init(mi, ma , mode, sx, sy, mw, mh, barbgcolor,  fbcolor)

	--self:SetParent(self) -- set the parent of the percent bar to self ( this window)
    self:SetMinMax(mi, ma) -- this sets the minimum value and maximum value you are getting percents of
    self:setMode(mode) -- mode 1 is horizontal , mode 2 is vertical
----------------------w---h-----
    self:setSizeOf(sx,sy) -- set main width of bar/height

    self:SetMaxWidth(mw) -- the greatest width in pixels your bar will be
    self:SetMaxHeight (mh) -- the max height your bar will be


---------------------------------------r-g-b-a----------
   -- self:SetBackColor(Turbine.UI.Color(0,0,0,.5)) -- set percentbar controls bg color
    self:setBarBgColor(barbgcolor)--Turbine.UI.Color(1,.5,.5, .7)) -- sets the visible color behind the bar when the bar shrinks
    self.frontLbl:SetBackColor(fbcolor)--Turbine.UI.Color(1,0,0,.577)
end
function percentBar:txtSetTop(t)
    self.txtLbl:SetTop(t)
end
function percentBar:txtSetLeft(l)
    self.txtLbl:SetLeft(l)
end
function percentBar:SetMaxWidth(w)
    self.mWidth = w
end
function percentBar:SetMaxHeight(h)
    self.mHeight = h
end
function percentBar:sFont(fonts) -- set font
    self.txtLbl:SetFont(fonts)

end
function percentBar:setTxt(txt)
	self.txtLbl:SetFontStyle( Turbine.UI.FontStyle.Outline )
    self.txtLbl:SetText(txt)
end
function percentBar:setBarBgColor(color)
    self.backLbl:SetBackColor(color);
end
function percentBar:SetBarImg(path)
    self.frontLbl:SetBackground(path);
    
end
function percentBar:setMode(mode)
    self.mode = tonumber(mode)
end
function percentBar:getPercent(max, curr)
    return curr / max;
end
function percentBar:Upd(percent)
    local cWidth = 0
    local cHeight = 0
    if (self.mode == 1) then
        cWidth = percent * self.mWidth
        if(cWidth > self.mWidth) then
            cWidth = self.mWidth
         end
         if(cWidth < 0) then
            cWidth = 0
         end
        self.frontLbl:SetSize(cWidth, self.mHeight)
            self:setCurrent(cWidth) 
    else
        cHeight = percent * self.mHeight
         if(cHeight > self.mHeight) then
            cHeight = self.mHeight
         end
         if(cHeight < 0) then
            cHeight = 0
         end
        self.frontLbl:SetSize(self.mWidth, cHeight)
            self:setCurrent(cHeight) 
        
    end

   
end
function percentBar:setPos(x , y)
	self.txtLbl:SetPosition(x, y)
	self.backLbl:SetPosition(x,y)
	self.frontLbl:SetPosition(x,y)
end
function percentBar:setSizeOf(w, h)
   
    self.txtLbl:SetSize(w,h)

    self.backLbl:SetSize(w,h)
end
function percentBar:SetMinMax(min,max)
    self.min = min
    self.max = max
end
function percentBar:setCurrent(curr)
    self.curr = curr;
end